


/******************************************
 *				 Maninder (Minu) Kahlon		    *
 *				 #961668300						    *
 *				 Tanya Ruppell				       *
 * 			 Ken Jackson					    *
 *				 Feb.12th 1998					    *
 *******************************************/
 
import java.io.*;
import java.util.*;
import java.lang.*;

public class StudentMarks {



/*********************************************************************
 This program processes student's information, name, number, courses 
 taken and school year the courses were taken.  It also looks at the 
 student's courses and the grades achieved, and previous academic status
 With this information a new acadamic status is determined
 **********************************************************************/
 
public static void main(java.lang.String[] args) throws IOException{
	DataInputStream stdin = new DataInputStream (System.in);
	
	/*Variables being used in this program. I have defined most of my 
	 variables below because I am only using them once.*/
	String status;
	int   course=0;
	double current_grade=0, past_grade=0, sum_pastgrade=0, sessional_avg, cummulative_avg;  
	double  sum_currentgrade=0, cummulative_tally=0, sessional_tally=0;
	
	/*Prompts user for information to determine student's info.*/
	System.out.println ("Input Current Session:");
	String current_session = stdin.readLine ();
	System.out.println ("Enter your Name:");
	String student_name = stdin.readLine();
	System.out.println ("Enter your Student Number:");
	String student_num = stdin.readLine();
	System.out.println ("Enter total number of courses taken:");
	int total_courses = Integer.parseInt (stdin.readLine());
	
	/*This loop will continue until all the courses are entered.*/
	while (total_courses != course){
		course = course+1;
		
		/*Prompts user to enter course code, grade received and session 
		  for each course.*/
		System.out.println ("Enter course code:");
		String course_code = stdin.readLine();
		System.out.println ("Grade received in " + course_code +":");
		int course_grade = Integer.parseInt (stdin.readLine());
		System.out.println ("Enter which session " + course_code + " was taken:");
		String course_session = stdin.readLine();
		
		/*Assigns the variables. 
		-Looks at 6th character of the course code to determine 
		 if it's a full Y,A,B or half F,S,H course.*/
		double course_value=0,full_course=1, half_course =0.5;
		switch (course_code.charAt(6)){
	   	
			/*The following does this in order;
			-Looks at the character
			-Count the amount of cummulative tally
			-Assigns charcter as a full or half course.
			-Times the grade by the course value.
			-Adds up the grades.*/
			case 'Y':                                  
			cummulative_tally++;                       
	   course_value = full_course;               
			past_grade = course_value * course_grade;  
			sum_pastgrade = sum_pastgrade + past_grade;
			break;
			case 'A':
			cummulative_tally++;
			course_value = full_course;
			past_grade = course_value * course_grade;
			sum_pastgrade = sum_pastgrade + past_grade;
			break;
			case 'B':
			cummulative_tally++;
			course_value = full_course;
			past_grade = course_value * course_grade;
			sum_pastgrade = sum_pastgrade + past_grade;
			break;
			/*Now we are looking at half courses, therefore I have
			 assigned the cummulative and sessional tally to add 0.5.*/
			case 'F':
			cummulative_tally= cummulative_tally + 0.5;
			course_value = half_course;
			past_grade = course_value * course_grade;
			sum_pastgrade = sum_pastgrade + past_grade;
			break;
			case 'S':
			cummulative_tally= cummulative_tally + 0.5;
			course_value = half_course;
			past_grade = course_value * course_grade;
			sum_pastgrade = sum_pastgrade + past_grade;
			break;
			case 'H':
			cummulative_tally = cummulative_tally + 0.5;
			course_value = half_course;
			past_grade = course_value * course_grade;
			sum_pastgrade = sum_pastgrade + past_grade;
			break;
			/*If anything other than F,A,B or F,S,H is entered, 
			 an erroe message will occur.*/
			default:
			System.out.println ("Error in input!!!");
		}
		
		
		/*If session of course is same as the current session then 
		  the grade of the recent session is calulated.
		  Also, it counts the amount of sessional tally by course weight.*/
		if ((current_session).equals(course_session)){
			half_course = sessional_tally + 0.5;
			full_course = sessional_tally++;	
			current_grade = course_grade * course_value;
			sum_currentgrade = sum_currentgrade + current_grade;
		}
		
	}	
	
		
		/*calculating sessional and cummulative averages.*/
		 sessional_avg = sum_currentgrade/sessional_tally;
		 cummulative_avg = sum_pastgrade/cummulative_tally;
		
		/*asks for student's previous acadamic status to 
		 determine new status later.*/				
		System.out.println ("Your previous acadamic status:");
		String previous_status = stdin.readLine();
		
		/*Keeps track of the status by looking at the averages.*/
		if (cummulative_avg > 60)
		status = ("In Good Standing");
		else if (previous_status.equals ("In Good Standing"))
		status = ("Acadamic Probation");
		else if (sessional_avg > 62)
		status = ("Acadamic Probation");
		else
		status = ("Suspension");
		
		/*Outputs of the program.*/
		System.out.println ("Student Name:" + student_name);
		System.out.println ("Student Number:" + student_num);
		System.out.println (("Sessional Average:")+Helper.twoDecPlaceString(sessional_avg));
		System.out.println (("Cummulative Average:")+Helper.twoDecPlaceString(cummulative_avg));
		System.out.println ("Current Acadamic Status:"+status);
		
		
		
		
}
}