/************************************************************************
*                                                                       *
*  This class contains one static method, blanks, that takes two int 	*
*  arguments, intValue and width, and returns a String containing the   *
*  number intValue, but padded on the left with blanks to ensure that	*
*  the length of the String is at least width.				*
*                                                                       *
*                                       Ken Jackson, 13 March 1998.     *
*                                                                       *
************************************************************************/


class Pad {

    public static String blanks (int intValue, int width) {

       // Convert intValue to a string, stringValue. 
       // If the length of stringValue is < width, pad stringValue 
       // on the left with blanks to make its length equal to width.

       String stringValue = String.valueOf(intValue) ;

       while ( stringValue.length() < width )
          stringValue = " " + stringValue ;

       return stringValue ;

    } // end blanks
}
        
